// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from vrxperience_msgs:msg/CabToModelCorrective.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_MODEL_CORRECTIVE__STRUCT_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_MODEL_CORRECTIVE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__vrxperience_msgs__msg__CabToModelCorrective __attribute__((deprecated))
#else
# define DEPRECATED__vrxperience_msgs__msg__CabToModelCorrective __declspec(deprecated)
#endif

namespace vrxperience_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CabToModelCorrective_
{
  using Type = CabToModelCorrective_<ContainerAllocator>;

  explicit CabToModelCorrective_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accelerator_additive = 0.0;
      this->accelerator_multiplicative = 0.0;
      this->brake_additive = 0.0;
      this->brake_multiplicative = 0.0;
      this->clutch_additive = 0.0;
      this->clutch_multiplicative = 0.0;
      this->parking_brake_additive = 0.0;
      this->parking_brake_multiplicative = 0.0;
      this->gear_box_take_over = false;
      this->gear_box_auto_mode = 0;
      this->wanted_gear = 0;
      this->shift_up = false;
      this->shift_down = false;
      this->is_ratio_limit = false;
      this->min_ratio = 0;
      this->max_ratio = 0;
    }
  }

  explicit CabToModelCorrective_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accelerator_additive = 0.0;
      this->accelerator_multiplicative = 0.0;
      this->brake_additive = 0.0;
      this->brake_multiplicative = 0.0;
      this->clutch_additive = 0.0;
      this->clutch_multiplicative = 0.0;
      this->parking_brake_additive = 0.0;
      this->parking_brake_multiplicative = 0.0;
      this->gear_box_take_over = false;
      this->gear_box_auto_mode = 0;
      this->wanted_gear = 0;
      this->shift_up = false;
      this->shift_down = false;
      this->is_ratio_limit = false;
      this->min_ratio = 0;
      this->max_ratio = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _accelerator_additive_type =
    double;
  _accelerator_additive_type accelerator_additive;
  using _accelerator_multiplicative_type =
    double;
  _accelerator_multiplicative_type accelerator_multiplicative;
  using _brake_additive_type =
    double;
  _brake_additive_type brake_additive;
  using _brake_multiplicative_type =
    double;
  _brake_multiplicative_type brake_multiplicative;
  using _clutch_additive_type =
    double;
  _clutch_additive_type clutch_additive;
  using _clutch_multiplicative_type =
    double;
  _clutch_multiplicative_type clutch_multiplicative;
  using _parking_brake_additive_type =
    double;
  _parking_brake_additive_type parking_brake_additive;
  using _parking_brake_multiplicative_type =
    double;
  _parking_brake_multiplicative_type parking_brake_multiplicative;
  using _gear_box_take_over_type =
    bool;
  _gear_box_take_over_type gear_box_take_over;
  using _gear_box_auto_mode_type =
    int16_t;
  _gear_box_auto_mode_type gear_box_auto_mode;
  using _wanted_gear_type =
    int16_t;
  _wanted_gear_type wanted_gear;
  using _shift_up_type =
    bool;
  _shift_up_type shift_up;
  using _shift_down_type =
    bool;
  _shift_down_type shift_down;
  using _is_ratio_limit_type =
    bool;
  _is_ratio_limit_type is_ratio_limit;
  using _min_ratio_type =
    int16_t;
  _min_ratio_type min_ratio;
  using _max_ratio_type =
    int16_t;
  _max_ratio_type max_ratio;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__accelerator_additive(
    const double & _arg)
  {
    this->accelerator_additive = _arg;
    return *this;
  }
  Type & set__accelerator_multiplicative(
    const double & _arg)
  {
    this->accelerator_multiplicative = _arg;
    return *this;
  }
  Type & set__brake_additive(
    const double & _arg)
  {
    this->brake_additive = _arg;
    return *this;
  }
  Type & set__brake_multiplicative(
    const double & _arg)
  {
    this->brake_multiplicative = _arg;
    return *this;
  }
  Type & set__clutch_additive(
    const double & _arg)
  {
    this->clutch_additive = _arg;
    return *this;
  }
  Type & set__clutch_multiplicative(
    const double & _arg)
  {
    this->clutch_multiplicative = _arg;
    return *this;
  }
  Type & set__parking_brake_additive(
    const double & _arg)
  {
    this->parking_brake_additive = _arg;
    return *this;
  }
  Type & set__parking_brake_multiplicative(
    const double & _arg)
  {
    this->parking_brake_multiplicative = _arg;
    return *this;
  }
  Type & set__gear_box_take_over(
    const bool & _arg)
  {
    this->gear_box_take_over = _arg;
    return *this;
  }
  Type & set__gear_box_auto_mode(
    const int16_t & _arg)
  {
    this->gear_box_auto_mode = _arg;
    return *this;
  }
  Type & set__wanted_gear(
    const int16_t & _arg)
  {
    this->wanted_gear = _arg;
    return *this;
  }
  Type & set__shift_up(
    const bool & _arg)
  {
    this->shift_up = _arg;
    return *this;
  }
  Type & set__shift_down(
    const bool & _arg)
  {
    this->shift_down = _arg;
    return *this;
  }
  Type & set__is_ratio_limit(
    const bool & _arg)
  {
    this->is_ratio_limit = _arg;
    return *this;
  }
  Type & set__min_ratio(
    const int16_t & _arg)
  {
    this->min_ratio = _arg;
    return *this;
  }
  Type & set__max_ratio(
    const int16_t & _arg)
  {
    this->max_ratio = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int16_t T_AUTO_MODE_MANUAL =
    0;
  static constexpr int16_t T_AUTO_MODE_REVERSE2 =
    1;
  static constexpr int16_t T_AUTO_MODE_REVERSE1 =
    2;
  static constexpr int16_t T_AUTO_MODE_NEUTRAL =
    3;
  static constexpr int16_t T_AUTO_MODE_PARK =
    4;
  static constexpr int16_t T_AUTO_MODE_LIMIT1 =
    5;
  static constexpr int16_t T_AUTO_MODE_LIMIT2 =
    6;
  static constexpr int16_t T_AUTO_MODE_LIMIT3 =
    7;
  static constexpr int16_t T_AUTO_MODE_LIMIT4 =
    8;
  static constexpr int16_t T_AUTO_MODE_RACE =
    9;
  static constexpr int16_t T_AUTO_MODE_DRIVE =
    10;
  static constexpr int16_t T_AUTO_MODE_OVER_DRIVE =
    11;
  static constexpr int16_t SEQUENTIAL =
    12;

  // pointer types
  using RawPtr =
    vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator> *;
  using ConstRawPtr =
    const vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__vrxperience_msgs__msg__CabToModelCorrective
    std::shared_ptr<vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__vrxperience_msgs__msg__CabToModelCorrective
    std::shared_ptr<vrxperience_msgs::msg::CabToModelCorrective_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CabToModelCorrective_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->accelerator_additive != other.accelerator_additive) {
      return false;
    }
    if (this->accelerator_multiplicative != other.accelerator_multiplicative) {
      return false;
    }
    if (this->brake_additive != other.brake_additive) {
      return false;
    }
    if (this->brake_multiplicative != other.brake_multiplicative) {
      return false;
    }
    if (this->clutch_additive != other.clutch_additive) {
      return false;
    }
    if (this->clutch_multiplicative != other.clutch_multiplicative) {
      return false;
    }
    if (this->parking_brake_additive != other.parking_brake_additive) {
      return false;
    }
    if (this->parking_brake_multiplicative != other.parking_brake_multiplicative) {
      return false;
    }
    if (this->gear_box_take_over != other.gear_box_take_over) {
      return false;
    }
    if (this->gear_box_auto_mode != other.gear_box_auto_mode) {
      return false;
    }
    if (this->wanted_gear != other.wanted_gear) {
      return false;
    }
    if (this->shift_up != other.shift_up) {
      return false;
    }
    if (this->shift_down != other.shift_down) {
      return false;
    }
    if (this->is_ratio_limit != other.is_ratio_limit) {
      return false;
    }
    if (this->min_ratio != other.min_ratio) {
      return false;
    }
    if (this->max_ratio != other.max_ratio) {
      return false;
    }
    return true;
  }
  bool operator!=(const CabToModelCorrective_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CabToModelCorrective_

// alias to use template instance with default allocator
using CabToModelCorrective =
  vrxperience_msgs::msg::CabToModelCorrective_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_MANUAL;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_REVERSE2;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_REVERSE1;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_NEUTRAL;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_PARK;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_LIMIT1;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_LIMIT2;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_LIMIT3;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_LIMIT4;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_RACE;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_DRIVE;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::T_AUTO_MODE_OVER_DRIVE;
template<typename ContainerAllocator>
constexpr int16_t CabToModelCorrective_<ContainerAllocator>::SEQUENTIAL;

}  // namespace msg

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_MODEL_CORRECTIVE__STRUCT_HPP_
