// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from vrxperience_msgs:msg/GPS.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__GPS__BUILDER_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__GPS__BUILDER_HPP_

#include "vrxperience_msgs/msg/detail/gps__struct.hpp"
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <utility>


namespace vrxperience_msgs
{

namespace msg
{

namespace builder
{

class Init_GPS_hdop
{
public:
  explicit Init_GPS_hdop(::vrxperience_msgs::msg::GPS & msg)
  : msg_(msg)
  {}
  ::vrxperience_msgs::msg::GPS hdop(::vrxperience_msgs::msg::GPS::_hdop_type arg)
  {
    msg_.hdop = std::move(arg);
    return std::move(msg_);
  }

private:
  ::vrxperience_msgs::msg::GPS msg_;
};

class Init_GPS_satellites
{
public:
  explicit Init_GPS_satellites(::vrxperience_msgs::msg::GPS & msg)
  : msg_(msg)
  {}
  Init_GPS_hdop satellites(::vrxperience_msgs::msg::GPS::_satellites_type arg)
  {
    msg_.satellites = std::move(arg);
    return Init_GPS_hdop(msg_);
  }

private:
  ::vrxperience_msgs::msg::GPS msg_;
};

class Init_GPS_altitude
{
public:
  explicit Init_GPS_altitude(::vrxperience_msgs::msg::GPS & msg)
  : msg_(msg)
  {}
  Init_GPS_satellites altitude(::vrxperience_msgs::msg::GPS::_altitude_type arg)
  {
    msg_.altitude = std::move(arg);
    return Init_GPS_satellites(msg_);
  }

private:
  ::vrxperience_msgs::msg::GPS msg_;
};

class Init_GPS_longitude
{
public:
  explicit Init_GPS_longitude(::vrxperience_msgs::msg::GPS & msg)
  : msg_(msg)
  {}
  Init_GPS_altitude longitude(::vrxperience_msgs::msg::GPS::_longitude_type arg)
  {
    msg_.longitude = std::move(arg);
    return Init_GPS_altitude(msg_);
  }

private:
  ::vrxperience_msgs::msg::GPS msg_;
};

class Init_GPS_latitude
{
public:
  explicit Init_GPS_latitude(::vrxperience_msgs::msg::GPS & msg)
  : msg_(msg)
  {}
  Init_GPS_longitude latitude(::vrxperience_msgs::msg::GPS::_latitude_type arg)
  {
    msg_.latitude = std::move(arg);
    return Init_GPS_longitude(msg_);
  }

private:
  ::vrxperience_msgs::msg::GPS msg_;
};

class Init_GPS_sensor_id
{
public:
  explicit Init_GPS_sensor_id(::vrxperience_msgs::msg::GPS & msg)
  : msg_(msg)
  {}
  Init_GPS_latitude sensor_id(::vrxperience_msgs::msg::GPS::_sensor_id_type arg)
  {
    msg_.sensor_id = std::move(arg);
    return Init_GPS_latitude(msg_);
  }

private:
  ::vrxperience_msgs::msg::GPS msg_;
};

class Init_GPS_ego_vehicle_id
{
public:
  explicit Init_GPS_ego_vehicle_id(::vrxperience_msgs::msg::GPS & msg)
  : msg_(msg)
  {}
  Init_GPS_sensor_id ego_vehicle_id(::vrxperience_msgs::msg::GPS::_ego_vehicle_id_type arg)
  {
    msg_.ego_vehicle_id = std::move(arg);
    return Init_GPS_sensor_id(msg_);
  }

private:
  ::vrxperience_msgs::msg::GPS msg_;
};

class Init_GPS_global_id
{
public:
  explicit Init_GPS_global_id(::vrxperience_msgs::msg::GPS & msg)
  : msg_(msg)
  {}
  Init_GPS_ego_vehicle_id global_id(::vrxperience_msgs::msg::GPS::_global_id_type arg)
  {
    msg_.global_id = std::move(arg);
    return Init_GPS_ego_vehicle_id(msg_);
  }

private:
  ::vrxperience_msgs::msg::GPS msg_;
};

class Init_GPS_header
{
public:
  Init_GPS_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_GPS_global_id header(::vrxperience_msgs::msg::GPS::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_GPS_global_id(msg_);
  }

private:
  ::vrxperience_msgs::msg::GPS msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::vrxperience_msgs::msg::GPS>()
{
  return vrxperience_msgs::msg::builder::Init_GPS_header();
}

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__GPS__BUILDER_HPP_
