// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from vrxperience_msgs:msg/LaserMeter.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__LASER_METER__BUILDER_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__LASER_METER__BUILDER_HPP_

#include "vrxperience_msgs/msg/detail/laser_meter__struct.hpp"
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <utility>


namespace vrxperience_msgs
{

namespace msg
{

namespace builder
{

class Init_LaserMeter_results
{
public:
  explicit Init_LaserMeter_results(::vrxperience_msgs::msg::LaserMeter & msg)
  : msg_(msg)
  {}
  ::vrxperience_msgs::msg::LaserMeter results(::vrxperience_msgs::msg::LaserMeter::_results_type arg)
  {
    msg_.results = std::move(arg);
    return std::move(msg_);
  }

private:
  ::vrxperience_msgs::msg::LaserMeter msg_;
};

class Init_LaserMeter_nearest_point
{
public:
  explicit Init_LaserMeter_nearest_point(::vrxperience_msgs::msg::LaserMeter & msg)
  : msg_(msg)
  {}
  Init_LaserMeter_results nearest_point(::vrxperience_msgs::msg::LaserMeter::_nearest_point_type arg)
  {
    msg_.nearest_point = std::move(arg);
    return Init_LaserMeter_results(msg_);
  }

private:
  ::vrxperience_msgs::msg::LaserMeter msg_;
};

class Init_LaserMeter_frame_count
{
public:
  explicit Init_LaserMeter_frame_count(::vrxperience_msgs::msg::LaserMeter & msg)
  : msg_(msg)
  {}
  Init_LaserMeter_nearest_point frame_count(::vrxperience_msgs::msg::LaserMeter::_frame_count_type arg)
  {
    msg_.frame_count = std::move(arg);
    return Init_LaserMeter_nearest_point(msg_);
  }

private:
  ::vrxperience_msgs::msg::LaserMeter msg_;
};

class Init_LaserMeter_sensor_id
{
public:
  explicit Init_LaserMeter_sensor_id(::vrxperience_msgs::msg::LaserMeter & msg)
  : msg_(msg)
  {}
  Init_LaserMeter_frame_count sensor_id(::vrxperience_msgs::msg::LaserMeter::_sensor_id_type arg)
  {
    msg_.sensor_id = std::move(arg);
    return Init_LaserMeter_frame_count(msg_);
  }

private:
  ::vrxperience_msgs::msg::LaserMeter msg_;
};

class Init_LaserMeter_ego_vehicle_id
{
public:
  explicit Init_LaserMeter_ego_vehicle_id(::vrxperience_msgs::msg::LaserMeter & msg)
  : msg_(msg)
  {}
  Init_LaserMeter_sensor_id ego_vehicle_id(::vrxperience_msgs::msg::LaserMeter::_ego_vehicle_id_type arg)
  {
    msg_.ego_vehicle_id = std::move(arg);
    return Init_LaserMeter_sensor_id(msg_);
  }

private:
  ::vrxperience_msgs::msg::LaserMeter msg_;
};

class Init_LaserMeter_global_id
{
public:
  explicit Init_LaserMeter_global_id(::vrxperience_msgs::msg::LaserMeter & msg)
  : msg_(msg)
  {}
  Init_LaserMeter_ego_vehicle_id global_id(::vrxperience_msgs::msg::LaserMeter::_global_id_type arg)
  {
    msg_.global_id = std::move(arg);
    return Init_LaserMeter_ego_vehicle_id(msg_);
  }

private:
  ::vrxperience_msgs::msg::LaserMeter msg_;
};

class Init_LaserMeter_header
{
public:
  Init_LaserMeter_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_LaserMeter_global_id header(::vrxperience_msgs::msg::LaserMeter::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_LaserMeter_global_id(msg_);
  }

private:
  ::vrxperience_msgs::msg::LaserMeter msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::vrxperience_msgs::msg::LaserMeter>()
{
  return vrxperience_msgs::msg::builder::Init_LaserMeter_header();
}

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__LASER_METER__BUILDER_HPP_
