// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vrxperience_msgs:msg/MovableTargets.idl
// generated code does not contain a copyright notice
#include "vrxperience_msgs/msg/detail/movable_targets__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `targets`
#include "vrxperience_msgs/msg/detail/movable_target__functions.h"

bool
vrxperience_msgs__msg__MovableTargets__init(vrxperience_msgs__msg__MovableTargets * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    vrxperience_msgs__msg__MovableTargets__fini(msg);
    return false;
  }
  // global_id
  // ego_vehicle_id
  // nearest_target
  // targets
  if (!vrxperience_msgs__msg__MovableTarget__Sequence__init(&msg->targets, 0)) {
    vrxperience_msgs__msg__MovableTargets__fini(msg);
    return false;
  }
  return true;
}

void
vrxperience_msgs__msg__MovableTargets__fini(vrxperience_msgs__msg__MovableTargets * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // global_id
  // ego_vehicle_id
  // nearest_target
  // targets
  vrxperience_msgs__msg__MovableTarget__Sequence__fini(&msg->targets);
}

vrxperience_msgs__msg__MovableTargets *
vrxperience_msgs__msg__MovableTargets__create()
{
  vrxperience_msgs__msg__MovableTargets * msg = (vrxperience_msgs__msg__MovableTargets *)malloc(sizeof(vrxperience_msgs__msg__MovableTargets));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vrxperience_msgs__msg__MovableTargets));
  bool success = vrxperience_msgs__msg__MovableTargets__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
vrxperience_msgs__msg__MovableTargets__destroy(vrxperience_msgs__msg__MovableTargets * msg)
{
  if (msg) {
    vrxperience_msgs__msg__MovableTargets__fini(msg);
  }
  free(msg);
}


bool
vrxperience_msgs__msg__MovableTargets__Sequence__init(vrxperience_msgs__msg__MovableTargets__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  vrxperience_msgs__msg__MovableTargets * data = NULL;
  if (size) {
    data = (vrxperience_msgs__msg__MovableTargets *)calloc(size, sizeof(vrxperience_msgs__msg__MovableTargets));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vrxperience_msgs__msg__MovableTargets__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vrxperience_msgs__msg__MovableTargets__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vrxperience_msgs__msg__MovableTargets__Sequence__fini(vrxperience_msgs__msg__MovableTargets__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vrxperience_msgs__msg__MovableTargets__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vrxperience_msgs__msg__MovableTargets__Sequence *
vrxperience_msgs__msg__MovableTargets__Sequence__create(size_t size)
{
  vrxperience_msgs__msg__MovableTargets__Sequence * array = (vrxperience_msgs__msg__MovableTargets__Sequence *)malloc(sizeof(vrxperience_msgs__msg__MovableTargets__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = vrxperience_msgs__msg__MovableTargets__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
vrxperience_msgs__msg__MovableTargets__Sequence__destroy(vrxperience_msgs__msg__MovableTargets__Sequence * array)
{
  if (array) {
    vrxperience_msgs__msg__MovableTargets__Sequence__fini(array);
  }
  free(array);
}
