// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from vrxperience_msgs:msg/MovableTargetsBoundingBoxes.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGETS_BOUNDING_BOXES__STRUCT_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGETS_BOUNDING_BOXES__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'bounding_boxes'
#include "vrxperience_msgs/msg/detail/movable_target_bounding_box__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__vrxperience_msgs__msg__MovableTargetsBoundingBoxes __attribute__((deprecated))
#else
# define DEPRECATED__vrxperience_msgs__msg__MovableTargetsBoundingBoxes __declspec(deprecated)
#endif

namespace vrxperience_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MovableTargetsBoundingBoxes_
{
  using Type = MovableTargetsBoundingBoxes_<ContainerAllocator>;

  explicit MovableTargetsBoundingBoxes_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->global_id = 0l;
      this->ego_vehicle_id = 0;
    }
  }

  explicit MovableTargetsBoundingBoxes_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->global_id = 0l;
      this->ego_vehicle_id = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _global_id_type =
    int32_t;
  _global_id_type global_id;
  using _ego_vehicle_id_type =
    int16_t;
  _ego_vehicle_id_type ego_vehicle_id;
  using _bounding_boxes_type =
    rosidl_runtime_cpp::BoundedVector<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator>, 30, typename ContainerAllocator::template rebind<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator>>::other>;
  _bounding_boxes_type bounding_boxes;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__global_id(
    const int32_t & _arg)
  {
    this->global_id = _arg;
    return *this;
  }
  Type & set__ego_vehicle_id(
    const int16_t & _arg)
  {
    this->ego_vehicle_id = _arg;
    return *this;
  }
  Type & set__bounding_boxes(
    const rosidl_runtime_cpp::BoundedVector<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator>, 30, typename ContainerAllocator::template rebind<vrxperience_msgs::msg::MovableTargetBoundingBox_<ContainerAllocator>>::other> & _arg)
  {
    this->bounding_boxes = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator> *;
  using ConstRawPtr =
    const vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__vrxperience_msgs__msg__MovableTargetsBoundingBoxes
    std::shared_ptr<vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__vrxperience_msgs__msg__MovableTargetsBoundingBoxes
    std::shared_ptr<vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MovableTargetsBoundingBoxes_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->global_id != other.global_id) {
      return false;
    }
    if (this->ego_vehicle_id != other.ego_vehicle_id) {
      return false;
    }
    if (this->bounding_boxes != other.bounding_boxes) {
      return false;
    }
    return true;
  }
  bool operator!=(const MovableTargetsBoundingBoxes_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MovableTargetsBoundingBoxes_

// alias to use template instance with default allocator
using MovableTargetsBoundingBoxes =
  vrxperience_msgs::msg::MovableTargetsBoundingBoxes_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGETS_BOUNDING_BOXES__STRUCT_HPP_
