// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from vrxperience_msgs:msg/RoadLinePolynom.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__ROAD_LINE_POLYNOM__STRUCT_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__ROAD_LINE_POLYNOM__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__vrxperience_msgs__msg__RoadLinePolynom __attribute__((deprecated))
#else
# define DEPRECATED__vrxperience_msgs__msg__RoadLinePolynom __declspec(deprecated)
#endif

namespace vrxperience_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadLinePolynom_
{
  using Type = RoadLinePolynom_<ContainerAllocator>;

  explicit RoadLinePolynom_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->line_id = 0;
      this->c0 = 0.0;
      this->c1 = 0.0;
      this->c2 = 0.0;
      this->c3 = 0.0;
      this->curvature_radius = 0.0;
      this->estimated_curvature_radius = 0.0;
    }
  }

  explicit RoadLinePolynom_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->line_id = 0;
      this->c0 = 0.0;
      this->c1 = 0.0;
      this->c2 = 0.0;
      this->c3 = 0.0;
      this->curvature_radius = 0.0;
      this->estimated_curvature_radius = 0.0;
    }
  }

  // field types and members
  using _line_id_type =
    int16_t;
  _line_id_type line_id;
  using _c0_type =
    double;
  _c0_type c0;
  using _c1_type =
    double;
  _c1_type c1;
  using _c2_type =
    double;
  _c2_type c2;
  using _c3_type =
    double;
  _c3_type c3;
  using _curvature_radius_type =
    double;
  _curvature_radius_type curvature_radius;
  using _estimated_curvature_radius_type =
    double;
  _estimated_curvature_radius_type estimated_curvature_radius;

  // setters for named parameter idiom
  Type & set__line_id(
    const int16_t & _arg)
  {
    this->line_id = _arg;
    return *this;
  }
  Type & set__c0(
    const double & _arg)
  {
    this->c0 = _arg;
    return *this;
  }
  Type & set__c1(
    const double & _arg)
  {
    this->c1 = _arg;
    return *this;
  }
  Type & set__c2(
    const double & _arg)
  {
    this->c2 = _arg;
    return *this;
  }
  Type & set__c3(
    const double & _arg)
  {
    this->c3 = _arg;
    return *this;
  }
  Type & set__curvature_radius(
    const double & _arg)
  {
    this->curvature_radius = _arg;
    return *this;
  }
  Type & set__estimated_curvature_radius(
    const double & _arg)
  {
    this->estimated_curvature_radius = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator> *;
  using ConstRawPtr =
    const vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__vrxperience_msgs__msg__RoadLinePolynom
    std::shared_ptr<vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__vrxperience_msgs__msg__RoadLinePolynom
    std::shared_ptr<vrxperience_msgs::msg::RoadLinePolynom_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadLinePolynom_ & other) const
  {
    if (this->line_id != other.line_id) {
      return false;
    }
    if (this->c0 != other.c0) {
      return false;
    }
    if (this->c1 != other.c1) {
      return false;
    }
    if (this->c2 != other.c2) {
      return false;
    }
    if (this->c3 != other.c3) {
      return false;
    }
    if (this->curvature_radius != other.curvature_radius) {
      return false;
    }
    if (this->estimated_curvature_radius != other.estimated_curvature_radius) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadLinePolynom_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadLinePolynom_

// alias to use template instance with default allocator
using RoadLinePolynom =
  vrxperience_msgs::msg::RoadLinePolynom_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__ROAD_LINE_POLYNOM__STRUCT_HPP_
