// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from vrxperience_msgs:msg/LaserMeterPoint.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__LASER_METER_POINT__STRUCT_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__LASER_METER_POINT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'intersection_point'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__vrxperience_msgs__msg__LaserMeterPoint __attribute__((deprecated))
#else
# define DEPRECATED__vrxperience_msgs__msg__LaserMeterPoint __declspec(deprecated)
#endif

namespace vrxperience_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LaserMeterPoint_
{
  using Type = LaserMeterPoint_<ContainerAllocator>;

  explicit LaserMeterPoint_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : intersection_point(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->hit = false;
      this->h_angle = 0.0f;
      this->v_angle = 0.0f;
      this->distance = 0.0f;
    }
  }

  explicit LaserMeterPoint_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : intersection_point(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->hit = false;
      this->h_angle = 0.0f;
      this->v_angle = 0.0f;
      this->distance = 0.0f;
    }
  }

  // field types and members
  using _hit_type =
    bool;
  _hit_type hit;
  using _h_angle_type =
    float;
  _h_angle_type h_angle;
  using _v_angle_type =
    float;
  _v_angle_type v_angle;
  using _intersection_point_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _intersection_point_type intersection_point;
  using _distance_type =
    float;
  _distance_type distance;

  // setters for named parameter idiom
  Type & set__hit(
    const bool & _arg)
  {
    this->hit = _arg;
    return *this;
  }
  Type & set__h_angle(
    const float & _arg)
  {
    this->h_angle = _arg;
    return *this;
  }
  Type & set__v_angle(
    const float & _arg)
  {
    this->v_angle = _arg;
    return *this;
  }
  Type & set__intersection_point(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->intersection_point = _arg;
    return *this;
  }
  Type & set__distance(
    const float & _arg)
  {
    this->distance = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator> *;
  using ConstRawPtr =
    const vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__vrxperience_msgs__msg__LaserMeterPoint
    std::shared_ptr<vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__vrxperience_msgs__msg__LaserMeterPoint
    std::shared_ptr<vrxperience_msgs::msg::LaserMeterPoint_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LaserMeterPoint_ & other) const
  {
    if (this->hit != other.hit) {
      return false;
    }
    if (this->h_angle != other.h_angle) {
      return false;
    }
    if (this->v_angle != other.v_angle) {
      return false;
    }
    if (this->intersection_point != other.intersection_point) {
      return false;
    }
    if (this->distance != other.distance) {
      return false;
    }
    return true;
  }
  bool operator!=(const LaserMeterPoint_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LaserMeterPoint_

// alias to use template instance with default allocator
using LaserMeterPoint =
  vrxperience_msgs::msg::LaserMeterPoint_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__LASER_METER_POINT__STRUCT_HPP_
