// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from vrxperience_msgs:msg/VehicleOutput.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__VEHICLE_OUTPUT__STRUCT_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__VEHICLE_OUTPUT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'cdg_speed'
// Member 'cdg_angular_speed'
// Member 'cdg_accel'
// Member 'cdg_angular_accel'
// Member 'cdg_position'
// Member 'cdg_orientation'
// Member 'hub_orientation'
// Member 'ground_normals'
// Member 'tire_force'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"
// Member 'hub_position'
// Member 'contact_points'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__vrxperience_msgs__msg__VehicleOutput __attribute__((deprecated))
#else
# define DEPRECATED__vrxperience_msgs__msg__VehicleOutput __declspec(deprecated)
#endif

namespace vrxperience_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VehicleOutput_
{
  using Type = VehicleOutput_<ContainerAllocator>;

  explicit VehicleOutput_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    cdg_speed(_init),
    cdg_angular_speed(_init),
    cdg_accel(_init),
    cdg_angular_accel(_init),
    cdg_position(_init),
    cdg_orientation(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lights = 0l;
      this->sirens = 0l;
      this->auxilary_lights = 0l;
      this->engine_state = false;
      this->consumption = 0.0;
      this->pollution = 0.0;
      this->engine_speed = 0.0;
      this->gear_engaged = 0l;
      this->gas_pedal = 0.0;
      this->brake_pedal = 0.0;
      this->hand_brake = 0.0;
      this->clutch_pedal = 0.0;
      this->gear_box_mode = 0l;
      this->effective_ignition_key_position = 0l;
      this->is_engine_retarder = false;
      this->brake_retarder_notch = 0l;
      this->trailer_brake = 0.0;
      this->transfer_choice = 0l;
      this->lock_diff_mode = 0l;
      this->force_lockup = false;
      this->plow_mode = 0l;
      this->steering_wheel_angle = 0.0;
      this->steering_wheel_speed = 0.0;
      this->steering_wheel_accel = 0.0;
      this->steering_wheel_torque = 0.0;
      this->hub_position.fill(geometry_msgs::msg::Point_<ContainerAllocator>{_init});
      this->hub_orientation.fill(geometry_msgs::msg::Vector3_<ContainerAllocator>{_init});
      std::fill<typename std::array<double, 4>::iterator, double>(this->wheel_rotation.begin(), this->wheel_rotation.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->wheel_rotation_speed.begin(), this->wheel_rotation_speed.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->brake_temperature.begin(), this->brake_temperature.end(), 0.0);
      std::fill<typename std::array<bool, 4>::iterator, bool>(this->abs_is_active.begin(), this->abs_is_active.end(), false);
      std::fill<typename std::array<bool, 4>::iterator, bool>(this->is_in_contact.begin(), this->is_in_contact.end(), false);
      this->contact_points.fill(geometry_msgs::msg::Point_<ContainerAllocator>{_init});
      this->ground_normals.fill(geometry_msgs::msg::Vector3_<ContainerAllocator>{_init});
      std::fill<typename std::array<double, 4>::iterator, double>(this->grip.begin(), this->grip.end(), 0.0);
      std::fill<typename std::array<int32_t, 4>::iterator, int32_t>(this->ground_index.begin(), this->ground_index.end(), 0l);
      std::fill<typename std::array<double, 4>::iterator, double>(this->lsr.begin(), this->lsr.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->slip_angle.begin(), this->slip_angle.end(), 0.0);
      this->tire_force.fill(geometry_msgs::msg::Vector3_<ContainerAllocator>{_init});
      std::fill<typename std::array<int32_t, 4>::iterator, int32_t>(this->lane_type.begin(), this->lane_type.end(), 0l);
      std::fill<typename std::array<double, 4>::iterator, double>(this->roughness_height.begin(), this->roughness_height.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->roughness_length.begin(), this->roughness_length.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->roughness_height_stddev.begin(), this->roughness_height_stddev.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->roughness_length_stddev.begin(), this->roughness_length_stddev.end(), 0.0);
      std::fill<typename std::array<int32_t, 4>::iterator, int32_t>(this->ground_type.begin(), this->ground_type.end(), 0l);
      std::fill<typename std::array<double, 4>::iterator, double>(this->water_height.begin(), this->water_height.end(), 0.0);
      std::fill<typename std::array<double, 512>::iterator, double>(this->custom_output.begin(), this->custom_output.end(), 0.0);
    }
  }

  explicit VehicleOutput_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    cdg_speed(_alloc, _init),
    cdg_angular_speed(_alloc, _init),
    cdg_accel(_alloc, _init),
    cdg_angular_accel(_alloc, _init),
    cdg_position(_alloc, _init),
    cdg_orientation(_alloc, _init),
    hub_position(_alloc),
    hub_orientation(_alloc),
    wheel_rotation(_alloc),
    wheel_rotation_speed(_alloc),
    brake_temperature(_alloc),
    abs_is_active(_alloc),
    is_in_contact(_alloc),
    contact_points(_alloc),
    ground_normals(_alloc),
    grip(_alloc),
    ground_index(_alloc),
    lsr(_alloc),
    slip_angle(_alloc),
    tire_force(_alloc),
    lane_type(_alloc),
    roughness_height(_alloc),
    roughness_length(_alloc),
    roughness_height_stddev(_alloc),
    roughness_length_stddev(_alloc),
    ground_type(_alloc),
    water_height(_alloc),
    custom_output(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lights = 0l;
      this->sirens = 0l;
      this->auxilary_lights = 0l;
      this->engine_state = false;
      this->consumption = 0.0;
      this->pollution = 0.0;
      this->engine_speed = 0.0;
      this->gear_engaged = 0l;
      this->gas_pedal = 0.0;
      this->brake_pedal = 0.0;
      this->hand_brake = 0.0;
      this->clutch_pedal = 0.0;
      this->gear_box_mode = 0l;
      this->effective_ignition_key_position = 0l;
      this->is_engine_retarder = false;
      this->brake_retarder_notch = 0l;
      this->trailer_brake = 0.0;
      this->transfer_choice = 0l;
      this->lock_diff_mode = 0l;
      this->force_lockup = false;
      this->plow_mode = 0l;
      this->steering_wheel_angle = 0.0;
      this->steering_wheel_speed = 0.0;
      this->steering_wheel_accel = 0.0;
      this->steering_wheel_torque = 0.0;
      this->hub_position.fill(geometry_msgs::msg::Point_<ContainerAllocator>{_alloc, _init});
      this->hub_orientation.fill(geometry_msgs::msg::Vector3_<ContainerAllocator>{_alloc, _init});
      std::fill<typename std::array<double, 4>::iterator, double>(this->wheel_rotation.begin(), this->wheel_rotation.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->wheel_rotation_speed.begin(), this->wheel_rotation_speed.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->brake_temperature.begin(), this->brake_temperature.end(), 0.0);
      std::fill<typename std::array<bool, 4>::iterator, bool>(this->abs_is_active.begin(), this->abs_is_active.end(), false);
      std::fill<typename std::array<bool, 4>::iterator, bool>(this->is_in_contact.begin(), this->is_in_contact.end(), false);
      this->contact_points.fill(geometry_msgs::msg::Point_<ContainerAllocator>{_alloc, _init});
      this->ground_normals.fill(geometry_msgs::msg::Vector3_<ContainerAllocator>{_alloc, _init});
      std::fill<typename std::array<double, 4>::iterator, double>(this->grip.begin(), this->grip.end(), 0.0);
      std::fill<typename std::array<int32_t, 4>::iterator, int32_t>(this->ground_index.begin(), this->ground_index.end(), 0l);
      std::fill<typename std::array<double, 4>::iterator, double>(this->lsr.begin(), this->lsr.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->slip_angle.begin(), this->slip_angle.end(), 0.0);
      this->tire_force.fill(geometry_msgs::msg::Vector3_<ContainerAllocator>{_alloc, _init});
      std::fill<typename std::array<int32_t, 4>::iterator, int32_t>(this->lane_type.begin(), this->lane_type.end(), 0l);
      std::fill<typename std::array<double, 4>::iterator, double>(this->roughness_height.begin(), this->roughness_height.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->roughness_length.begin(), this->roughness_length.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->roughness_height_stddev.begin(), this->roughness_height_stddev.end(), 0.0);
      std::fill<typename std::array<double, 4>::iterator, double>(this->roughness_length_stddev.begin(), this->roughness_length_stddev.end(), 0.0);
      std::fill<typename std::array<int32_t, 4>::iterator, int32_t>(this->ground_type.begin(), this->ground_type.end(), 0l);
      std::fill<typename std::array<double, 4>::iterator, double>(this->water_height.begin(), this->water_height.end(), 0.0);
      std::fill<typename std::array<double, 512>::iterator, double>(this->custom_output.begin(), this->custom_output.end(), 0.0);
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _cdg_speed_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _cdg_speed_type cdg_speed;
  using _cdg_angular_speed_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _cdg_angular_speed_type cdg_angular_speed;
  using _cdg_accel_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _cdg_accel_type cdg_accel;
  using _cdg_angular_accel_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _cdg_angular_accel_type cdg_angular_accel;
  using _cdg_position_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _cdg_position_type cdg_position;
  using _cdg_orientation_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _cdg_orientation_type cdg_orientation;
  using _lights_type =
    int32_t;
  _lights_type lights;
  using _sirens_type =
    int32_t;
  _sirens_type sirens;
  using _auxilary_lights_type =
    int32_t;
  _auxilary_lights_type auxilary_lights;
  using _engine_state_type =
    bool;
  _engine_state_type engine_state;
  using _consumption_type =
    double;
  _consumption_type consumption;
  using _pollution_type =
    double;
  _pollution_type pollution;
  using _engine_speed_type =
    double;
  _engine_speed_type engine_speed;
  using _gear_engaged_type =
    int32_t;
  _gear_engaged_type gear_engaged;
  using _gas_pedal_type =
    double;
  _gas_pedal_type gas_pedal;
  using _brake_pedal_type =
    double;
  _brake_pedal_type brake_pedal;
  using _hand_brake_type =
    double;
  _hand_brake_type hand_brake;
  using _clutch_pedal_type =
    double;
  _clutch_pedal_type clutch_pedal;
  using _gear_box_mode_type =
    int32_t;
  _gear_box_mode_type gear_box_mode;
  using _effective_ignition_key_position_type =
    int32_t;
  _effective_ignition_key_position_type effective_ignition_key_position;
  using _is_engine_retarder_type =
    bool;
  _is_engine_retarder_type is_engine_retarder;
  using _brake_retarder_notch_type =
    int32_t;
  _brake_retarder_notch_type brake_retarder_notch;
  using _trailer_brake_type =
    double;
  _trailer_brake_type trailer_brake;
  using _transfer_choice_type =
    int32_t;
  _transfer_choice_type transfer_choice;
  using _lock_diff_mode_type =
    int32_t;
  _lock_diff_mode_type lock_diff_mode;
  using _force_lockup_type =
    bool;
  _force_lockup_type force_lockup;
  using _plow_mode_type =
    int32_t;
  _plow_mode_type plow_mode;
  using _steering_wheel_angle_type =
    double;
  _steering_wheel_angle_type steering_wheel_angle;
  using _steering_wheel_speed_type =
    double;
  _steering_wheel_speed_type steering_wheel_speed;
  using _steering_wheel_accel_type =
    double;
  _steering_wheel_accel_type steering_wheel_accel;
  using _steering_wheel_torque_type =
    double;
  _steering_wheel_torque_type steering_wheel_torque;
  using _hub_position_type =
    std::array<geometry_msgs::msg::Point_<ContainerAllocator>, 4>;
  _hub_position_type hub_position;
  using _hub_orientation_type =
    std::array<geometry_msgs::msg::Vector3_<ContainerAllocator>, 4>;
  _hub_orientation_type hub_orientation;
  using _wheel_rotation_type =
    std::array<double, 4>;
  _wheel_rotation_type wheel_rotation;
  using _wheel_rotation_speed_type =
    std::array<double, 4>;
  _wheel_rotation_speed_type wheel_rotation_speed;
  using _brake_temperature_type =
    std::array<double, 4>;
  _brake_temperature_type brake_temperature;
  using _abs_is_active_type =
    std::array<bool, 4>;
  _abs_is_active_type abs_is_active;
  using _is_in_contact_type =
    std::array<bool, 4>;
  _is_in_contact_type is_in_contact;
  using _contact_points_type =
    std::array<geometry_msgs::msg::Point_<ContainerAllocator>, 4>;
  _contact_points_type contact_points;
  using _ground_normals_type =
    std::array<geometry_msgs::msg::Vector3_<ContainerAllocator>, 4>;
  _ground_normals_type ground_normals;
  using _grip_type =
    std::array<double, 4>;
  _grip_type grip;
  using _ground_index_type =
    std::array<int32_t, 4>;
  _ground_index_type ground_index;
  using _lsr_type =
    std::array<double, 4>;
  _lsr_type lsr;
  using _slip_angle_type =
    std::array<double, 4>;
  _slip_angle_type slip_angle;
  using _tire_force_type =
    std::array<geometry_msgs::msg::Vector3_<ContainerAllocator>, 4>;
  _tire_force_type tire_force;
  using _lane_type_type =
    std::array<int32_t, 4>;
  _lane_type_type lane_type;
  using _roughness_height_type =
    std::array<double, 4>;
  _roughness_height_type roughness_height;
  using _roughness_length_type =
    std::array<double, 4>;
  _roughness_length_type roughness_length;
  using _roughness_height_stddev_type =
    std::array<double, 4>;
  _roughness_height_stddev_type roughness_height_stddev;
  using _roughness_length_stddev_type =
    std::array<double, 4>;
  _roughness_length_stddev_type roughness_length_stddev;
  using _ground_type_type =
    std::array<int32_t, 4>;
  _ground_type_type ground_type;
  using _water_height_type =
    std::array<double, 4>;
  _water_height_type water_height;
  using _custom_output_type =
    std::array<double, 512>;
  _custom_output_type custom_output;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__cdg_speed(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->cdg_speed = _arg;
    return *this;
  }
  Type & set__cdg_angular_speed(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->cdg_angular_speed = _arg;
    return *this;
  }
  Type & set__cdg_accel(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->cdg_accel = _arg;
    return *this;
  }
  Type & set__cdg_angular_accel(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->cdg_angular_accel = _arg;
    return *this;
  }
  Type & set__cdg_position(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->cdg_position = _arg;
    return *this;
  }
  Type & set__cdg_orientation(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->cdg_orientation = _arg;
    return *this;
  }
  Type & set__lights(
    const int32_t & _arg)
  {
    this->lights = _arg;
    return *this;
  }
  Type & set__sirens(
    const int32_t & _arg)
  {
    this->sirens = _arg;
    return *this;
  }
  Type & set__auxilary_lights(
    const int32_t & _arg)
  {
    this->auxilary_lights = _arg;
    return *this;
  }
  Type & set__engine_state(
    const bool & _arg)
  {
    this->engine_state = _arg;
    return *this;
  }
  Type & set__consumption(
    const double & _arg)
  {
    this->consumption = _arg;
    return *this;
  }
  Type & set__pollution(
    const double & _arg)
  {
    this->pollution = _arg;
    return *this;
  }
  Type & set__engine_speed(
    const double & _arg)
  {
    this->engine_speed = _arg;
    return *this;
  }
  Type & set__gear_engaged(
    const int32_t & _arg)
  {
    this->gear_engaged = _arg;
    return *this;
  }
  Type & set__gas_pedal(
    const double & _arg)
  {
    this->gas_pedal = _arg;
    return *this;
  }
  Type & set__brake_pedal(
    const double & _arg)
  {
    this->brake_pedal = _arg;
    return *this;
  }
  Type & set__hand_brake(
    const double & _arg)
  {
    this->hand_brake = _arg;
    return *this;
  }
  Type & set__clutch_pedal(
    const double & _arg)
  {
    this->clutch_pedal = _arg;
    return *this;
  }
  Type & set__gear_box_mode(
    const int32_t & _arg)
  {
    this->gear_box_mode = _arg;
    return *this;
  }
  Type & set__effective_ignition_key_position(
    const int32_t & _arg)
  {
    this->effective_ignition_key_position = _arg;
    return *this;
  }
  Type & set__is_engine_retarder(
    const bool & _arg)
  {
    this->is_engine_retarder = _arg;
    return *this;
  }
  Type & set__brake_retarder_notch(
    const int32_t & _arg)
  {
    this->brake_retarder_notch = _arg;
    return *this;
  }
  Type & set__trailer_brake(
    const double & _arg)
  {
    this->trailer_brake = _arg;
    return *this;
  }
  Type & set__transfer_choice(
    const int32_t & _arg)
  {
    this->transfer_choice = _arg;
    return *this;
  }
  Type & set__lock_diff_mode(
    const int32_t & _arg)
  {
    this->lock_diff_mode = _arg;
    return *this;
  }
  Type & set__force_lockup(
    const bool & _arg)
  {
    this->force_lockup = _arg;
    return *this;
  }
  Type & set__plow_mode(
    const int32_t & _arg)
  {
    this->plow_mode = _arg;
    return *this;
  }
  Type & set__steering_wheel_angle(
    const double & _arg)
  {
    this->steering_wheel_angle = _arg;
    return *this;
  }
  Type & set__steering_wheel_speed(
    const double & _arg)
  {
    this->steering_wheel_speed = _arg;
    return *this;
  }
  Type & set__steering_wheel_accel(
    const double & _arg)
  {
    this->steering_wheel_accel = _arg;
    return *this;
  }
  Type & set__steering_wheel_torque(
    const double & _arg)
  {
    this->steering_wheel_torque = _arg;
    return *this;
  }
  Type & set__hub_position(
    const std::array<geometry_msgs::msg::Point_<ContainerAllocator>, 4> & _arg)
  {
    this->hub_position = _arg;
    return *this;
  }
  Type & set__hub_orientation(
    const std::array<geometry_msgs::msg::Vector3_<ContainerAllocator>, 4> & _arg)
  {
    this->hub_orientation = _arg;
    return *this;
  }
  Type & set__wheel_rotation(
    const std::array<double, 4> & _arg)
  {
    this->wheel_rotation = _arg;
    return *this;
  }
  Type & set__wheel_rotation_speed(
    const std::array<double, 4> & _arg)
  {
    this->wheel_rotation_speed = _arg;
    return *this;
  }
  Type & set__brake_temperature(
    const std::array<double, 4> & _arg)
  {
    this->brake_temperature = _arg;
    return *this;
  }
  Type & set__abs_is_active(
    const std::array<bool, 4> & _arg)
  {
    this->abs_is_active = _arg;
    return *this;
  }
  Type & set__is_in_contact(
    const std::array<bool, 4> & _arg)
  {
    this->is_in_contact = _arg;
    return *this;
  }
  Type & set__contact_points(
    const std::array<geometry_msgs::msg::Point_<ContainerAllocator>, 4> & _arg)
  {
    this->contact_points = _arg;
    return *this;
  }
  Type & set__ground_normals(
    const std::array<geometry_msgs::msg::Vector3_<ContainerAllocator>, 4> & _arg)
  {
    this->ground_normals = _arg;
    return *this;
  }
  Type & set__grip(
    const std::array<double, 4> & _arg)
  {
    this->grip = _arg;
    return *this;
  }
  Type & set__ground_index(
    const std::array<int32_t, 4> & _arg)
  {
    this->ground_index = _arg;
    return *this;
  }
  Type & set__lsr(
    const std::array<double, 4> & _arg)
  {
    this->lsr = _arg;
    return *this;
  }
  Type & set__slip_angle(
    const std::array<double, 4> & _arg)
  {
    this->slip_angle = _arg;
    return *this;
  }
  Type & set__tire_force(
    const std::array<geometry_msgs::msg::Vector3_<ContainerAllocator>, 4> & _arg)
  {
    this->tire_force = _arg;
    return *this;
  }
  Type & set__lane_type(
    const std::array<int32_t, 4> & _arg)
  {
    this->lane_type = _arg;
    return *this;
  }
  Type & set__roughness_height(
    const std::array<double, 4> & _arg)
  {
    this->roughness_height = _arg;
    return *this;
  }
  Type & set__roughness_length(
    const std::array<double, 4> & _arg)
  {
    this->roughness_length = _arg;
    return *this;
  }
  Type & set__roughness_height_stddev(
    const std::array<double, 4> & _arg)
  {
    this->roughness_height_stddev = _arg;
    return *this;
  }
  Type & set__roughness_length_stddev(
    const std::array<double, 4> & _arg)
  {
    this->roughness_length_stddev = _arg;
    return *this;
  }
  Type & set__ground_type(
    const std::array<int32_t, 4> & _arg)
  {
    this->ground_type = _arg;
    return *this;
  }
  Type & set__water_height(
    const std::array<double, 4> & _arg)
  {
    this->water_height = _arg;
    return *this;
  }
  Type & set__custom_output(
    const std::array<double, 512> & _arg)
  {
    this->custom_output = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t E_GROUND_ASPHALT =
    0;
  static constexpr int32_t E_GROUND_CONRETE =
    1;
  static constexpr int32_t E_GROUND_GRASS =
    2;
  static constexpr int32_t E_GROUND_COBBLESTONE =
    3;

  // pointer types
  using RawPtr =
    vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator> *;
  using ConstRawPtr =
    const vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__vrxperience_msgs__msg__VehicleOutput
    std::shared_ptr<vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__vrxperience_msgs__msg__VehicleOutput
    std::shared_ptr<vrxperience_msgs::msg::VehicleOutput_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VehicleOutput_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->cdg_speed != other.cdg_speed) {
      return false;
    }
    if (this->cdg_angular_speed != other.cdg_angular_speed) {
      return false;
    }
    if (this->cdg_accel != other.cdg_accel) {
      return false;
    }
    if (this->cdg_angular_accel != other.cdg_angular_accel) {
      return false;
    }
    if (this->cdg_position != other.cdg_position) {
      return false;
    }
    if (this->cdg_orientation != other.cdg_orientation) {
      return false;
    }
    if (this->lights != other.lights) {
      return false;
    }
    if (this->sirens != other.sirens) {
      return false;
    }
    if (this->auxilary_lights != other.auxilary_lights) {
      return false;
    }
    if (this->engine_state != other.engine_state) {
      return false;
    }
    if (this->consumption != other.consumption) {
      return false;
    }
    if (this->pollution != other.pollution) {
      return false;
    }
    if (this->engine_speed != other.engine_speed) {
      return false;
    }
    if (this->gear_engaged != other.gear_engaged) {
      return false;
    }
    if (this->gas_pedal != other.gas_pedal) {
      return false;
    }
    if (this->brake_pedal != other.brake_pedal) {
      return false;
    }
    if (this->hand_brake != other.hand_brake) {
      return false;
    }
    if (this->clutch_pedal != other.clutch_pedal) {
      return false;
    }
    if (this->gear_box_mode != other.gear_box_mode) {
      return false;
    }
    if (this->effective_ignition_key_position != other.effective_ignition_key_position) {
      return false;
    }
    if (this->is_engine_retarder != other.is_engine_retarder) {
      return false;
    }
    if (this->brake_retarder_notch != other.brake_retarder_notch) {
      return false;
    }
    if (this->trailer_brake != other.trailer_brake) {
      return false;
    }
    if (this->transfer_choice != other.transfer_choice) {
      return false;
    }
    if (this->lock_diff_mode != other.lock_diff_mode) {
      return false;
    }
    if (this->force_lockup != other.force_lockup) {
      return false;
    }
    if (this->plow_mode != other.plow_mode) {
      return false;
    }
    if (this->steering_wheel_angle != other.steering_wheel_angle) {
      return false;
    }
    if (this->steering_wheel_speed != other.steering_wheel_speed) {
      return false;
    }
    if (this->steering_wheel_accel != other.steering_wheel_accel) {
      return false;
    }
    if (this->steering_wheel_torque != other.steering_wheel_torque) {
      return false;
    }
    if (this->hub_position != other.hub_position) {
      return false;
    }
    if (this->hub_orientation != other.hub_orientation) {
      return false;
    }
    if (this->wheel_rotation != other.wheel_rotation) {
      return false;
    }
    if (this->wheel_rotation_speed != other.wheel_rotation_speed) {
      return false;
    }
    if (this->brake_temperature != other.brake_temperature) {
      return false;
    }
    if (this->abs_is_active != other.abs_is_active) {
      return false;
    }
    if (this->is_in_contact != other.is_in_contact) {
      return false;
    }
    if (this->contact_points != other.contact_points) {
      return false;
    }
    if (this->ground_normals != other.ground_normals) {
      return false;
    }
    if (this->grip != other.grip) {
      return false;
    }
    if (this->ground_index != other.ground_index) {
      return false;
    }
    if (this->lsr != other.lsr) {
      return false;
    }
    if (this->slip_angle != other.slip_angle) {
      return false;
    }
    if (this->tire_force != other.tire_force) {
      return false;
    }
    if (this->lane_type != other.lane_type) {
      return false;
    }
    if (this->roughness_height != other.roughness_height) {
      return false;
    }
    if (this->roughness_length != other.roughness_length) {
      return false;
    }
    if (this->roughness_height_stddev != other.roughness_height_stddev) {
      return false;
    }
    if (this->roughness_length_stddev != other.roughness_length_stddev) {
      return false;
    }
    if (this->ground_type != other.ground_type) {
      return false;
    }
    if (this->water_height != other.water_height) {
      return false;
    }
    if (this->custom_output != other.custom_output) {
      return false;
    }
    return true;
  }
  bool operator!=(const VehicleOutput_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VehicleOutput_

// alias to use template instance with default allocator
using VehicleOutput =
  vrxperience_msgs::msg::VehicleOutput_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr int32_t VehicleOutput_<ContainerAllocator>::E_GROUND_ASPHALT;
template<typename ContainerAllocator>
constexpr int32_t VehicleOutput_<ContainerAllocator>::E_GROUND_CONRETE;
template<typename ContainerAllocator>
constexpr int32_t VehicleOutput_<ContainerAllocator>::E_GROUND_GRASS;
template<typename ContainerAllocator>
constexpr int32_t VehicleOutput_<ContainerAllocator>::E_GROUND_COBBLESTONE;

}  // namespace msg

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__VEHICLE_OUTPUT__STRUCT_HPP_
